byte sem = 5;
byte critical = 0; /* ghost variable
                      for verification only */

active [10] proctype P() {
  do ::
        printf("P%d non-critical actions\n", _pid);
        atomic { /* "wait(sem)" */
          sem > 0;
          sem-- 
        }
        /* begin critical section */
        critical++;
	printf("P%d uses shared recourses\n", _pid);
        assert (critical <= 5);
        critical--;
        /* end critical section */
        sem++    /* "signal(sem)" */
  od
}

